ccb/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('ccb_app.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
]

ccb_app/models.py
from datetime import datetime

from django.contrib.auth.models import User
from django.core.exceptions import ValidationError
from django.db import models

# Create your models here.
from django.urls import reverse
from django.utils import timezone


# class RoomType(models.Model):
#     name = models.CharField(max_length=50)
#
#     def __str__(self):
#         return f'{self.name}'


class Room(models.Model):
    ROOM_TYPES = (('camera_dubla', 'Camera Dubla'), ('apartament', 'Apartament'), ('facility', 'Facilitate'),
                  ('exterior', 'Exterior'), ('interior', 'Interior'),)
    name = models.CharField(max_length=50)
    # room_type = models.ForeignKey(RoomType, on_delete=models.CASCADE)
    room_type = models.CharField(max_length=30, choices=ROOM_TYPES)
    beds = models.IntegerField()
    capacity = models.IntegerField()
    description = models.TextField()
    # availability = models.BooleanField(default=False)
    price = models.DecimalField(max_digits=19, decimal_places=0)
    slug = models.SlugField()

    # image = models.Ma
    # image = models.ImageField(upload_to='static/room_images/', default='static/not_available.png')

    def __str__(self):
        return f'{self.name}'

    def get_absolute_url(self):
        return reverse("ccb_app:room_details", kwargs={
            'slug': self.slug
        })


class Reservation(models.Model):
    # DE CE ESTE RESERVATION_STATUS SCRIS CU LITERE MARI??? e constanta
    RESERVATION_STATUS = (
        ('searching', 'Cauta'), ('confirmed', 'Confirmata'), ('6pm_release', 'Retinuta'), ('pending', 'In curs de confirmare'),
        ('canceled', 'Anulata'), ('wait_list', 'In asteptare'), ('no_show', 'No show'), ('checked-in', 'Checked-in'),
        ('checked-out', 'Checked-out'))
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    # room = models.ForeignKey(Room, on_delete=models.CASCADE)
    check_in = models.DateField(default=datetime.now())
    check_out = models.DateField(default=datetime.now())
    status = models.CharField(max_length=15, choices=RESERVATION_STATUS)
    booked = models.BooleanField(default=False)

    def __str__(self):
        return f'Rezervarea lui {self.user} din {self.check_in} pana in {self.check_out} este {self.status}'


class ReservationItem(models.Model):
    # user = models.ForeignKey(User, on_delete=models.CASCADE)
    reservation = models.ForeignKey(Reservation, on_delete=models.CASCADE)
    booked = models.BooleanField(default=False)
    room = models.ForeignKey(Room, on_delete=models.CASCADE)
    quantity = models.IntegerField(default=1)

    def __str__(self):
        return f'in rezervarea lui {self.reservation.user} au intrat {self.room} si s-au dus in {self.reservation}'


class Facility(models.Model):
    FACILITY_TYPES = (('foisor', 'Foisor'), ('ciubar', 'Ciubar'), ('spalatorie', 'Spalatorie'))
    name = models.CharField(max_length=50)
    facility_type = models.CharField(max_length=50, choices=FACILITY_TYPES)
    description = models.TextField()

    def __str__(self):
        return f'{self.name}'


class RoomImage(models.Model):
    image = models.ImageField(null=True, blank=True, upload_to='static/images')
    room = models.ForeignKey(Room, on_delete=models.CASCADE)

    def __str__(self):
        return f'{self.image}'


class FacilityImage(models.Model):
    image = models.ImageField(null=True, blank=True, upload_to='static/images')
    facility = models.ForeignKey(Facility, on_delete=models.CASCADE)

    def __str__(self):
        return f'{self.image}'


class SpecialOffer(models.Model):
    name = models.CharField(max_length=100)
    room = models.ForeignKey(Room, on_delete=models.CASCADE)
    start_date = models.DateTimeField(default=timezone.now)
    end_date = models.DateTimeField(default=timezone.now)

    def __str__(self):
        return f'{self.name}'


def telephone_valid(value):
    valid_characters = '0123456789-().'
    for character in value:
        if character not in valid_characters:
            raise ValidationError(f"{character} is not a valid character for phone number (accepted only '-().')")
    if value[:2] != "07":
        raise ValidationError(f"{value} is not a Romanian phone number")
    numeric_phone = list(
        filter(lambda character: character not in '-().', value))  # scoate caracterele care nu sunt cifre din value
    print(f"{numeric_phone}")
    if len(numeric_phone) != 10:
        raise ValidationError(f"{value} length is invalid")

    # api de sms


# def email_valid() o functie de validare a adresei de email -
# trimitere email cu link de validare; sau logare cu fbook, gmail

class ClientProfile(models.Model):
    name = models.CharField(max_length=50, default="", name='Nume')
    surname = models.CharField(max_length=50, default="", name='Prenume')
    phone_number = models.CharField(max_length=18, default="0", validators=[
        telephone_valid], name='Numar de telefon')
    email = models.EmailField(null=True, blank=True)  # de adaugat constraint pe view
    content = models.TextField()

    def __str__(self):
        return self.name


class Review(models.Model):
    title = models.CharField(max_length=75)
    content = models.TextField()
    datetime = models.DateTimeField(default=timezone.now)
    reservation_item = models.ForeignKey(Reservation, on_delete=models.CASCADE)

    def __str__(self):
        return self.title


class Comment(models.Model):
    review = models.ForeignKey(Review, related_name='review', on_delete=models.CASCADE)
    parent_comment = models.ForeignKey('self', on_delete=models.CASCADE, null=True, blank=True)
    author_name = models.ForeignKey(ClientProfile, related_name='author_name', on_delete=models.CASCADE)
    content = models.TextField()
    datetime = models.DateTimeField(auto_now=True)
    accepted = models.BooleanField(default=False)

    class Meta:
        ordering = ['-datetime']

    def __str__(self):
        return f"{self.author_name} - {self.content}"

templates/pages/accommodation.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Cazare{% endblock %}

{% block body %}
    <div id="centerDoc" class="container-xl">
        <h3>Aceasta este Casa cu Brazi!</h3>
        <h3>Camere Duble</h3>
        <div class="row">
            {% for room_with_images in rooms_with_images %}
                <div class="card col-xl-3 col-lg-4 col-md-6 col-sm-12">
                    <div class="card-body">
                        <h5 class="card-title">{{ room_with_images.room.name }}</h5>
                        <img src="{{ room_with_images.images.0.image.url }}" class="card-img-top"
                             alt="{{ room_with_images.room.name }}">
                        <p class="card-text">{{ room_with_images.room.price }} lei/camera/noapte</p>
{#                        <a href="{% url 'reservation_create' room_with_images.room.id %}" class="btn btn-primary m-1">Rezerva</a>#}
                        <a href="{% url 'room_details' room_with_images.room.id %}" class="btn btn-primary m-2"
{#                        <a href="{{ room_with_images.room.get_absolute_url }}" class="btn btn-primary m-2"#}
                           role="button">Detalii</a>
                    </div>
                </div>
            {% endfor %}

        </div>
        <h3>Apartamente</h3>
        <div class="row">
            {% for apartment_with_images in apartments_with_images %}
                <div class="card col-xl-3 col-lg-4 col-md-6 col-sm-12">
                    <div class="card-body">
                        <h5 class="card-title">{{ apartment_with_images.room.name }}</h5>
                        <img src="{{ apartment_with_images.images.0.image.url }}" class="card-img-top"
                             alt="{{ apartment_with_images.room.name }}">
                        <p class="card-text">{{ apartment_with_images.room.price }} lei/camera/noapte</p>
{#                        <a href="{% url 'reservation_create' apartment_with_images.room.id %}" class="btn btn-primary m-1">Rezerva</a>#}
                        <a href="{% url 'room_details' apartment_with_images.room.id %}" class="btn btn-primary m-2"
                           role="button">Detalii</a>
                    </div>
                </div>
            {% endfor %}
        </div>
    </div>
{% endblock %}

templates/pages/availability_view.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Date de intrare{% endblock %}

{% block body %}
    <div id="centerDoc" class="container-xl">
        <h3>Aceasta este Casa cu Brazi!</h3>
        <form action="" method="post"> {# {% url 'availability' %} #}
            {% csrf_token %}
            {{ form.as_p }}
            <input type="Submit" name="submit" value="Verifica"/>
            {#                        <button type="submit">submit</button>#}
        </form>
        {% if submit_button == "Verifica" %}
            <h1> Your check-in date is {{ check_in }}</h1>
            <h1> Your check-out date is {{ check_out }}</h1>
{#            <p>acestea sunt camerele disponibile: {{ available_rooms }}</p>#}
{#            <p>acestea sunt camerele noastre: {{ room_list }}</p>#}
{#            <p>Pentru ca avem aceste rezervari:</p>#}
{#            {% for reservation in reservation_list %}#}
{#                <p>{{ reservation }}</p>#}
{#                <p>{{ reservation.check_in }}{{ reservation.room }}</p>#}
{#                <p>{{ reservation.check_out }}{{ reservation.room }}</p>#}
{#            {% endfor %}#}
            {#            {% if {{ len(available_rooms) }} > 0 %}#}
            {% for room in available_rooms %}
                <div class="row">
                    <div class="card col-xl-3 col-lg-4 col-md-6 col-sm-12">
                        <div class="card-body">
                            <h5 class="card-title">{{ room.name }}</h5>
                            <img src="{{ detail.image.url }}" class="card-img-top" alt="{{ room.name }}">
                            <p class="card-text">{{ room.room_type }}</p>
                            <p class="card-text">{{ room.description }}</p>

                            <p class="card-text">{{ room.price }} lei/camera/noapte</p>
{#                            <select class="form-select" aria-label="Default select example">#}
{#                                <option selected>Selecteaza</option>#}
{#                                <option value="0">0</option>#}
{#                                <option value="1">1</option>#}
{#                            </select>#}
{#                            <a href="#" class="btn btn-primary m-1">Selecteaza</a> {# {% url 'reservation_create' %} #}
{#                            <a href="{% url 'availability' %}" class="btn btn-primary m-1">Disponibilitate</a>#}
                            <a href="{% url 'availability' %}" class="btn btn-primary m-1">Selecteaza</a>
                        </div>
                    </div>
                </div>
            {% endfor %}
            {#            {% endif %}#}
        {% endif %}
    </div>
{% endblock %}

templates/pages/facility_all_view.html
{% extends 'pages/admin_page.html' %}
{% load static %}

{% block title %}All Facilities{% endblock %}

{% block admin_content %}
    {% for facility in facilities %}
        <div class="row">
            <div class="card col-xl-3 col-lg-4 col-md-6 col-sm-12"
                 style="max-width: 20rem;">
                <div class="card-header fw-bold">{{ facility.name }}</div>
{#                <img src="{{ room.image.url }}" class="card-img-top"> {# alt="{{ room.name }}" #}
                <div class="card-body">

                    {% if perms.facility.details_facility %}
                        <a class="btn btn-success btn-sm" href="{% url 'facility_details' facility.id %}" role="button">Vezi
                            Facilitatea</a>
                    {% endif %}
                    {% if perms.facility.change_facility %}
                        <a class="btn btn-primary btn-sm" href="{% url 'facility_update' facility.id %}" role="button">Actualizeaza
                            Facilitatea</a>
                    {% endif %}
                    {% if perms.facility.delete_facility %}
                        <a class="btn btn-danger btn-sm" href="{% url 'facility_delete' facility.id %}"
                           role="button">Sterge Facilitatea</a>
                    {% endif %}
                </div>
            </div>
        </div>
    {% endfor %}
{% endblock %}

templates/pages/facility_delete.html
{% extends 'pages/admin_page.html' %}
{% load static %}

{% block title %}Delete Facility{% endblock %}


{% block admin_content %}
    <p>Are you sure you want to delete {{ facility.name }}?</p>
    <form method="post">
        {% csrf_token %}
        <button type="submit">Sterge</button>
    </form>

{% endblock %}

templates/pages/facility_image_delete.html
{% extends 'pages/admin_page.html' %}
{% load static %}

{% block title %}Delete Facility Image{% endblock %}


{% block admin_content %}
    <p>Are you sure you want to delete {{ facilityimage.image }}?</p>
    <form method="post">
        {% csrf_token %}
        <button type="submit">Sterge</button>
    </form>

{% endblock %}

templates/pages/image_all_view.html
{% extends 'pages/admin_page.html' %}
{% load static %}

{% block title %}AllImages{% endblock %}

{% block admin_content %}
    {#    <img src="{{ post.image.url }}">#}
    {% for image in images %}
{#        <img src="{{ image.image.url }}" alt="{{ image.image }}">#}
        <div class="row">
            <div class="card col-xl-3 col-lg-4 col-md-6 col-sm-12"
                 style="max-width: 20rem;">
                <div class="card-header fw-bold"> {{ image.image.image }}</div>
                <img src="{{ image.image.url }}" class="card-img-top" alt="{{ image.image }}">
                <div class="card-body">

                    {% if perms.image.delete_image %}
                        <a class="btn btn-danger btn-sm" href="{% url 'image_delete' image.id %}"
                           role="button">Sterge Poza</a>
                    {% endif %}

                </div>
            </div>
        </div>
    {% endfor %}
    {% for image in facility_images %}
{#         <img src="{{ image.image.url }}" alt="{{ image.image }}">#}
        <div class="row">
            <div class="card col-xl-3 col-lg-4 col-md-6 col-sm-12"
                 style="max-width: 20rem;">
                <div class="card-header fw-bold"> {{ image.facility_images.image }}</div>
                <img src="{{ image.image.url }}" class="card-img-top" alt="{{ image.image }}">
                <div class="card-body">

                    {% if perms.facility_image.delete_facility %}
                        <a class="btn btn-danger btn-sm" href="{% url 'facility_image_delete' image.id %}"
                           role="button">Sterge Poza</a>
                    {% endif %}

                </div>
            </div>
        </div>
    {% endfor %}
{% endblock %}

templates/pages/image_create.html
{% extends 'pages/admin_page.html' %}
{% load static %}

{% block title %}Create Image{% endblock %}

{% block admin_content %}
    <form method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit">Adauga imaginea</button>
    </form>

{% endblock %}

templates/pages/price.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Preturi{% endblock %}

templates/pages/register.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Inregistreaza-te{% endblock %}

{% block rezerva %}{% endblock %}

{% block body %}
    <form method="post">
        {% csrf_token %}
        {{ user_form.as_p }}
        {{ client_profile_form.as_p }}
        <button type="submit">Register</button>
    </form>
{% endblock %}

templates/pages/reservation_all_view.html
{% extends 'pages/admin_page.html' %}
{% load static %}

{% block title %}All Reservations{% endblock %}

{% block admin_content %}
    {% for reservation in reservations %}
        <div class="row">
            <div class="card col-xl-3 col-lg-4 col-md-6 col-sm-12"
                 style="max-width: 20rem;">
                <div class="card-header fw-bold">{{ reservation.room }}</div>
{#                <img src="{{ room.image.url }}" class="card-img-top"> {# alt="{{ room.name }}" #}
{#                <div class="card-body">#}
{##}
{#                    {% if perms.facility.details_facility %}#}
{#                        <a class="btn btn-success btn-sm" href="{% url 'facility_details' reservation.id %}" role="button">Vezi#}
{#                            Facilitatea</a>#}
{#                    {% endif %}#}
{#                    {% if perms.facility.change_facility %}#}
{#                        <a class="btn btn-primary btn-sm" href="{% url 'facility_update' reservation.id %}" role="button">Actualizeaza#}
{#                            Facilitatea</a>#}
{#                    {% endif %}#}
{#                    {% if perms.facility.delete_facility %}#}
{#                        <a class="btn btn-danger btn-sm" href="{% url 'facility_delete' reservation.id %}"#}
{#                           role="button">Sterge Facilitatea</a>#}
{#                    {% endif %}#}
                </div>
            </div>
        </div>
    {% endfor %}
{% endblock %}

templates/pages/review.html
{% extends 'base.html' %}
{% load static %}

{% block title %}Opinii{% endblock %}

templates/pages/room_all_view.html
{% extends 'pages/admin_page.html' %}
{% load static %}

{% block title %}AllRooms{% endblock %}

{% block admin_content %}
    {% for room in rooms %}
        <div class="row">
            <div class="card col-xl-3 col-lg-4 col-md-6 col-sm-12"
                 style="max-width: 20rem;">
                <div class="card-header fw-bold">{{ room.name }}</div>
{#                <img src="{{ room.image.url }}" class="card-img-top"> {# alt="{{ room.name }}" #}
                <div class="card-body">

                    {% if perms.rooms.details_room %}
                        <a class="btn btn-success btn-sm" href="{% url 'room_details' room.id %}" role="button">Vezi
                            Camera</a>
                    {% endif %}
                    {% if perms.rooms.change_room %}
                        <a class="btn btn-primary btn-sm" href="{% url 'room_update' room.id %}" role="button">Actualizeaza
                            Camera</a>
                    {% endif %}
                    {% if perms.rooms.delete_room %}
                        <a class="btn btn-danger btn-sm" href="{% url 'room_delete' room.id %}"
                           role="button">Sterge Camera</a>
                    {% endif %}
                </div>
            </div>
        </div>
    {% endfor %}
{% endblock %}

templates/pages/room_create.html
{% extends 'pages/admin_page.html' %}
{% load static %}

{% block title %}Create Room{% endblock %}

{% block admin_content %}
    <form method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit">Creaza camera</button>
    </form>

{% endblock %}

templates/pages/room_update.html
{% extends 'pages/admin_page.html' %}
{% load static %}

{% block title %}Update Room{% endblock %}

{% block admin_content %}
    <form method="post" enctype="multipart/form-data">
        {% csrf_token %}
        {{ form.as_p }}
        <button type="submit">Actualizeaza camera</button>
    </form>

{% endblock %}